#!/usr/bin/env python
import numpy as np
from scipy.special import erf
from numpy import exp,sqrt,pi

def fun(a,n,s,x):
    y=np.array(x)-s
    y=np.piecewise(y,[y>=0,y<=-a],[0,lambda y:y+a/2,lambda y:a*(exp(-n*n/4)-exp(-n*n*(a+2*y)*(a+2*y)/4/a/a))/2/n/sqrt(pi)/erf(n/2) +(a+2*y)*(erf(n/2)-erf(n*(0.5+y/a)))/4/erf(n/2)])
    return y

def dfun(a,n,s,x):
    y=np.array(x)-s
    y=np.piecewise(y,[y>=0,y<=-a],[0,1,lambda y: 0.5-erf(n*(0.5+y/a))/2/erf(n/2)])
    return y

def newton_inv(a,n,s,y):
    dxmax=a/10
    resmax=1e-14
    y[y>0]=0
    x=y+s
    res=1.
    niter=0
    while( (np.max(abs(res))>resmax) and (niter<50)):
        res=fun(a,n,s,x)-y
        df=dfun(a,n,s,x)
        dx=np.zeros_like(y)
        mask=(abs(df)!=0)
        dx[mask]=-res[mask]/df[mask]
        dx[dx> dxmax] =  dxmax
        dx[dx<-dxmax] = -dxmax
        x = x + dx
        niter = niter + 1
        i=np.argmax(abs(res))
    if (np.max(abs(res))>resmax):
        print("Warning: Newton's method does not converge!")
    return x

path='si2_band.dat'
data=np.genfromtxt(path,dtype='float')

eig=data[:,1]

m=np.loadtxt('ht_args')
a=m[0]
n=m[1]
s=m[2]
nbnd=m[3]
nk=round(len(eig)/nbnd)

x=newton_inv(a,n,s,eig)
data[:,1]=x
with open(path,'w') as f:
    for i in range(len(eig)):
        if i%nk==0 and i>0:
            f.write("\n")
        f.write(f' {data[i,0]: 9.8E} {data[i,1]: 10.8E}\n')
