#!/bin/bash
ecut=100
power=3
eps=1e-4
home=$(pwd)
seedname=si2
ht=/home/kaiwu/software/qe-ht/bin/ht.x
pw=/home/kaiwu/software/qe-7.2/bin/pw.x
wan=/home/kaiwu/software/wannier90-3.1.0/wannier90.x
pw2wan=/home/kaiwu/software/qe-7.2/bin/pw2wannier90.x
pseudo_dir="/work/kaiwu/qe/pseudo"
SLURM_JOB_CPUS_PER_NODE=8
for i in {3..10}
do
    echo $i
    rm -rf $home/k$i
    cp -r $home/ktmp $home/k$i
    sed -ri '1,$s/ecutwfc(.*?)/ecutwfc\ =\ '$ecut'/g' $home/k$i/ht/scf.in
    sed -ri '1,$s/ecutwfc(.*?)/ecutwfc\ =\ '$ecut'/g' $home/k$i/nscf/scf.in
    sed -ri '1,$s/ecutwfc(.*?)/ecutwfc\ =\ '$ecut'/g' $home/k$i/nscf/band.in
    sed -ri '1,$s/ecutwfc(.*?)/ecutwfc\ =\ '$ecut'/g' $home/k$i/wannier/scf.in
    sed -ri '1,$s/ecutwfc(.*?)/ecutwfc\ =\ '$ecut'/g' $home/k$i/wan_ht/scf.in
    sed -ri '1,$s/power(.*?)/power\ =\ '$power'/g' $home/k$i/ht/band.in
    sed -ri '1,$s/qr_eps(.*?)/qr_eps\ =\ '$eps'/g' $home/k$i/ht/band.in
    sed -ri '1,$s/power(.*?)/power\ =\ '$power'/g' $home/k$i/wan_ht/transform.py
    sed -i '$s/.*/'$i\ $i\ $i' 0 0 0/' $home/k$i/ht/scf.in
    sed -i '$s/.*/'$i\ $i\ $i' 0 0 0/' $home/k$i/nscf/scf.in
    sed -i '$s/.*/'$i\ $i\ $i' 0 0 0/' $home/k$i/wannier/scf.in
    sed -i '$s/.*/'$i\ $i\ $i' 0 0 0/' $home/k$i/wan_ht/scf.in
    sed -i "s|^\s*pseudo_dir\s*=.*|  pseudo_dir = '$pseudo_dir',|" $home/k$i/ht/scf.in
    sed -i "s|^\s*pseudo_dir\s*=.*|  pseudo_dir = '$pseudo_dir',|" $home/k$i/nscf/scf.in
    sed -i "s|^\s*pseudo_dir\s*=.*|  pseudo_dir = '$pseudo_dir',|" $home/k$i/wannier/scf.in
    sed -i "s|^\s*pseudo_dir\s*=.*|  pseudo_dir = '$pseudo_dir',|" $home/k$i/wan_ht/scf.in
    sed -ri '1,$s/mp_grid(.*?)/mp_grid\ =\ '$i\ $i\ $i'/g' $home/k$i/wannier/si2.win
    sed -ri '1,$s/mp_grid(.*?)/mp_grid\ =\ '$i\ $i\ $i'/g' $home/k$i/wan_ht/si2.win
    cd $home/k$i/ht
    echo ht
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 < scf.in >scf.out
    $ht < band.in >band.out
    rm -rf *wfc* ${seedname}.save
    cd $home/k$i/nscf
    echo nscf
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 < scf.in >scf.out
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 < band.in >band.out
    rm -rf *wfc* ${seedname}.save
    #cd $home/k$i/wannier
    #echo wannier
    #wannier_kpoints.py
    #mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 <scf.in >scf.out
    #mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan -pp ${seedname}
    #mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw2wan < pw2wan.in > pw2wan.out
    #mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan ${seedname}
    #rm -rf *wfc* ${seedname}.save *mmn *chk
    cd $home/k$i/wan_ht
    echo wan_ht
    wannier_kpoints.py
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 <scf.in >scf.out
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan -pp ${seedname}
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw2wan < pw2wan.in > pw2wan.out
    ./transform.py
    mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan ${seedname}
    ./inv_transform.py
    rm -rf *wfc* ${seedname}.save *mmn *chk
done
