#!/usr/bin/env python
import numpy as np
from scipy.special import erf
from numpy import exp,sqrt,pi

def fun(a,n,s,x):
    y=np.array(x)-s
    y=np.piecewise(y,[y>=0,y<=-a],[0,lambda y:y+a/2,lambda y:a*(exp(-n*n/4)-exp(-n*n*(a+2*y)*(a+2*y)/4/a/a))/2/n/sqrt(pi)/erf(n/2) +(a+2*y)*(erf(n/2)-erf(n*(0.5+y/a)))/4/erf(n/2)])
    return y

def dfun(a,n,s,x):
    y=np.array(x)-s
    y=np.piecewise(y,[y>=0,y<=-a],[0,1,lambda y: 0.5-erf(n*(0.5+y/a))/2/erf(n/2)])
    return y

def newton_inv(a,n,s,y):
    dxmax=a/10
    resmax=1e-14
    x=y+s
    res=1.
    niter=0
    while( (np.max(abs(res))>resmax) and (niter<50)):
        res=fun(a,n,s,x)-y
        df=dfun(a,n,s,x)
        dx=np.zeros_like(y)
        mask=(abs(df)!=0)
        dx[mask]=-res[mask]/df[mask]
        dx[dx> dxmax] =  dxmax
        dx[dx<-dxmax] = -dxmax
        x = x + dx
        niter = niter + 1
    if (np.max(abs(res))>resmax):
        print("Warning: Newton's method does not converge!")
    return x

path='si2.eig'
data=np.genfromtxt(path,dtype='float')

nbnd=int(np.max(data[:,0]))
nk=int(np.max(data[:,1]))
s=np.max(data[:,2])
eig=np.reshape(data[:,2],[nk,nbnd])
a=4*(np.max(eig[:,-1])-np.min(eig[:,-1]))
power = 4
n=power = 4
y=fun(a,n,s,eig)

data[:,2]=np.reshape(y,nbnd*nk)
np.savetxt(path, data, fmt=' %4d %4d % 17.12f')
np.savetxt('ht_args',[a,n,s,nbnd])
