#!/bin/bash
#SBATCH -J QE
#SBATCH -o out
#SBATCH -e err
#SBATCH -N 1 -n 48
#SBATCH -p normal
#scontrol update job $SLURM_JOB_ID JobName $(pwd|awk -F '/' '{printf("%s/%s",$(NF-1),$NF)}')

seedname=$(find . -name "*.win"|cut -d '/' -f2|cut -d '.' -f1)
wannier_kpoints.py
wan=/public/home/jlyang/wuk/bin/wannier90-opi/wannier90.x
echo scf
mpirun -np $SLURM_JOB_CPUS_PER_NODE pw.o -npool 4 <scf.in >scf.out
echo prepare
mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan -pp ${seedname}
echo pw2wan
mpirun -np 12 /public/home/jlyang/wuk/bin/qe-7.0/bin/pw2wannier90.x < pw2wan.in > pw2wan.out
./transform.py
echo wannier90
mpirun -np $SLURM_JOB_CPUS_PER_NODE $wan ${seedname}
./inv_transform.py
