#!/bin/bash
#SBATCH -J QE
#SBATCH -o out
#SBATCH -e err
#SBATCH -N 1 -n 48
#SBATCH -p short

seedname=$(find . -name "*.win"|cut -d '/' -f2|cut -d '.' -f1)
wannier_kpoints.py
wan=/home/kaiwu/software/wannier90-3.1.0/wannier90.x
pw2wan=/home/kaiwu/software/qe-7.2/bin/pw2wannier90.x
pw=/home/kaiwu/software/qe-7.2/bin/pw.x
SLURM_JOB_CPUS_PER_NODE=8
echo scf
mpirun -np $SLURM_JOB_CPUS_PER_NODE $pw -npool 2 <scf.in >scf.out

start=`date +%s.%N`
mpirun -np 1 $wan -pp ${seedname}
mpirun -np 1 $pw2wan < pw2wan.in > pw2wan.out
mpirun -np 1 $wan ${seedname}
end=`date +%s.%N`

runtime=$( echo "$end - $start" | bc -l )
echo $runtime
