#!/usr/bin/env python
import numpy as np
import matplotlib.pyplot as plt
import importlib
import os
import sys
import seaborn as sns
import pandas as pd
sys.path.append(os.getenv('HOME')+'/script')
import load_qe
import cal_band

hartree=27.211386245988
bohr=0.529177210903
cmap=sns.color_palette()
sns.set(style="ticks")

def read_eig(path):
    bandinfo=cal_band.band_data(path)
    eigenvalues=bandinfo['eigenvalues']
    fermi=eigenvalues[0,3]
    eigenvalues-=fermi
    return eigenvalues

fig,ax = plt.subplots(figsize=(3.1,5))
nb=8
wa=[]
x=np.array([3,4,5,6,7,8,9,10])
path='p1'

l0,=ax.plot([],[],color=cmap[0],linewidth=1.5)
l1,=ax.plot([],[],color=cmap[1],linewidth=1.5)
l2,=ax.plot([],[],color=cmap[2],linewidth=1.5)
l3,=ax.plot([],[],color=cmap[3],linewidth=1.5)
l4,=ax.plot([],[],color='k',linewidth=1.5)
legend1 = plt.legend((l0,l1,l2,l3,l4),('HT n=1','HT n=2','HT n=3','HT n=4','Wannier'),loc='lower left',frameon=False)
ax.add_artist(legend1)
ax.set_ylabel('Error (eV)')
ax.set_xlabel('Number of SCF k-points ($N_k$)')
plt.savefig('accuracy.pdf', bbox_inches='tight')
plt.show()
