#!/usr/bin/env python
import numpy as np
import f90nml
import re

nk=7
ncell=[1,1,1]
xyz=np.array([[ 0.000000000, 0.000000000, 0.000000000], [ 0.000000000, 0.500000000, 0.500000000], [ 0.500000000, 0.000000000, 0.500000000], [ 0.500000000, 0.500000000, 0.000000000], [ 0.750000000, 0.250000000, 0.750000000], [ 0.250000000, 0.250000000, 0.250000000], [ 0.250000000, 0.750000000, 0.750000000], [ 0.750000000, 0.750000000, 0.250000000]])
C = 5.4688*np.diag(ncell)
for i in range(3):
    pos=xyz
    v=np.zeros(3)
    v[i]=1
    for j in range(1,ncell[i]):
        pos=np.concatenate((pos,xyz+v*j))
    xyz = pos
    xyz[:,i]/=ncell[i]
with open('template','r') as f:
    data=f.readlines()
with open('scf.in','w') as f:
    for i in data:
        if i.strip()[:3]=='nat':
            f.write('  nat = '+str(np.prod(ncell)*8)+'\n')
        elif i.strip()[:4]=='nbnd':
            f.write('  nbnd = '+str(np.prod(ncell)*16+4)+'\n')
        elif i.strip()[:16]=='ATOMIC_POSITIONS':
            f.write('ATOMIC_POSITIONS crystal\n')
            for p in xyz:
                f.write('Si {: 12.10f} {: 12.10f} {: 12.10f}\n'.format(*p))
        elif i.strip()[:15]=='CELL_PARAMETERS':
            f.write('CELL_PARAMETERS (angstrom)\n')
            for p in C:
                f.write('{: 12.10f} {: 12.10f} {: 12.10f}\n'.format(*p))
        elif i.strip()[:8]=='K_POINTS':
            f.write('K_POINTS automatic\n')
            f.write(str(nk)+' '+str(nk)+' '+str(nk)+' 0 0 0\n')
        elif re.match(r'^-?\d+\.?\d*$', i.strip().split()[0]) is None:
            f.write(i)
