#!/bin/sh
#SBATCH -J QE
#SBATCH -o out
#SBATCH -e err
#SBATCH -N 1 -n 48
#SBATCH -p short
if [ -z "$SLURM_JOB_CPUS_PER_NODE" ];then
    SLURM_JOB_CPUS_PER_NODE=12
else
    scontrol update job $SLURM_JOB_ID JobName $(pwd|awk -F '/' '{printf("%s/%s",$(NF-1),$NF)}')
fi

SLURM_JOB_CPUS_PER_NODE=16
./structure.py
mpirun -np $SLURM_JOB_CPUS_PER_NODE pw.of -npool 4 < scf.in >scf.out
ht.of < band.in >band.out
rm -rf *wfc* si8.mix* si8.save
